/* -*-  Mode: C++; c-file-style: "gnu"; indent-tabs-mode:nil; -*- */
/*
 * Copyright (c) 2010 INRIA
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as 
 * published by the Free Software Foundation;
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * Author: Rao Naveed Bin Rais <Naveed-Bin.Rais@inria.fr>
 */
 
#ifndef HANDLE_NOTIFICATIONS_CLASS_H
#define HANDLE_NOTIFICATIONS_CLASS_H

#include <map>
#include <list>
#include "ns3/header.h"
#include "ns3/mac48-address.h"
#include "ns3/packet.h"
#include "ns3/llc-snap-header.h"
#include "ipv4-interface.h"


#pragma once

namespace ns3 {

class MedehaIntraManetNotifHeader : public Header 
{
public:

  MedehaIntraManetNotifHeader ();
  ~MedehaIntraManetNotifHeader ();

  static TypeId GetTypeId (void);
  virtual TypeId GetInstanceTypeId (void) const;
  virtual void Print (std::ostream &os) const;
  virtual uint32_t GetSerializedSize (void) const;
  virtual void Serialize (Buffer::Iterator start) const;
  virtual uint32_t Deserialize (Buffer::Iterator start);
  
  int GetType (void) { return m_type; }
  void SetMsgID (int type) { m_type = type; }
  int GetProtocol (void) { return m_protocol; }
  void SetProtocol (int protocol) { m_protocol = protocol; }
  Ipv4Address GetDstIPAddress (void) { return m_dstIPAddress; }
  void SetDstIPAddress (Ipv4Address dstIPAddress) { m_dstIPAddress = dstIPAddress; }

private:
  uint16_t  m_type;
  uint16_t  m_protocol;
  Ipv4Address  m_dstIPAddress;
};

} // ns3 namespace

#endif
